<p><a href="https://travis-ci.org/alexdalitz/dnsruby"><img src="https://travis-ci.org/alexdalitz/dnsruby.svg?branch=master" alt="Build Status" /></a> <a href="https://coveralls.io/r/alexdalitz/dnsruby?branch=master"><img src="https://img.shields.io/coveralls/alexdalitz/dnsruby.svg" alt="Coverage Status" /></a></p>
<p><img src="http://caerkettontech.com/dnsruby/DNSRuby-colour-mid.png" width="200" height="200" /></p>
<h1 id="dnsruby">Dnsruby</h1>
<p>Dnsruby is a pure Ruby DNS client library which implements a stub resolver. It aims to comply with all DNS RFCs.</p>
<p>Dnsruby presents an enhanced API for DNS. It is based on Ruby’s core resolv.rb Resolv API, but has been much extended to provide a complete DNS implementation.</p>
<p>Dnsruby runs a single I/O thread to handle all concurrent queries. It is therefore suitable for high volume DNS applications.</p>
<p>The following is a (non-exhaustive) list of features :</p>
<ul>
<li><p>Implemented RRs : A, AAAA, AFSDB, ANY, CAA, CERT, CNAME, DNAME, GPOS, HINFO, ISDN, LOC, MB, MG, MINFO, MR, MX, NAPTR, NS, NSAP, NXT, OPT, PTR, PX, RP, RT, SOA, SPF, SRV, TKEY, TSIG, TXT, WKS, X25, DNSKEY, RRSIG, NSEC, NSEC3, NSEC3PARAM, DS, DLV</p></li>
<li><p>Generic RR types supported (RFC3597)</p></li>
<li><p>(Signed) Zone transfer (AXFR and IXFR) supported</p></li>
<li><p>(Signed) Dynamic updates supported</p></li>
<li><p>DNSSEC validation supported</p></li>
</ul>
<h2 id="dependencies">Dependencies</h2>
<p>Dnsruby can run with no dependencies. However, if you wish to use TSIG or DNSSEC then the OpenSSL library must be available. This is a part of the Ruby standard library, but appears not to be present on all Ruby platforms. If it is not available, then the test code will not run the tests which require it. Code which attempts to use the library (if it is not present) will raise an exception.</p>
<h2 id="demo-code">Demo Code</h2>
<p>The demo folder contains some example programs using Dnsruby. These examples include a basic dig tool (rubydig) and a tool to concurrently resolve many names, amongst others.</p>
<h2 id="unit-tests">Unit Tests</h2>
<p>Tests require a current version of minitest (see the .gemspec file for which version is required). In order for the tests to run successfully you may need to have the bundler gem installed and run <code>bundle</code> or <code>bundle install</code> from the project root to install a suitable version of minitest.</p>
<p>There are “online” and “offline” tests. You can use rake to conveniently run the tests. From the project root you can run:</p>
<pre><code>rake test          # run all tests
rake test_offline  # run only offline tests
rake test_online   # run only online tests</code></pre>
<p>If you get the following error when running rake test tasks, then you may need to preface the command with bundle exec to ensure that the gem versions specified in Gemfile.lock are used at runtime:</p>
<pre><code>bundle exec rake test</code></pre>
<h2 id="usage-help">Usage Help</h2>
<p>There are a couple of blog articles that might be helpful in understanding how to use Dnsruby. These used to be hosted by Nominet UK, however the original content has been copied to the dnsruby github wiki at :</p>
<p>https://github.com/alexdalitz/dnsruby/wiki</p>
<h2 id="contactlinks">Contact/Links</h2>
<table>
<thead>
<tr class="header">
<th>Link Type</th>
<th>Link/Text</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Author Email</td>
<td>alex@caerkettontech.com</td>
</tr>
<tr class="even">
<td>Github</td>
<td>https://github.com/alexdalitz/dnsruby</td>
</tr>
<tr class="odd">
<td>Google Group</td>
<td>https://groups.google.com/forum/#!forum/dnsruby</td>
</tr>
<tr class="even">
<td>Rubygems</td>
<td>http://rubygems.org/gems/dnsruby/</td>
</tr>
</tbody>
</table>
